import processing.core.*; 

import controlP5.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Raindrop extends PApplet {


ControlP5 controlP5;

public int CSizex=1000,CSizey=750; //canvas size
public float b,xRD,yRD,n0,dndl,R,PS,xRDn,yRDn;
float xi,xi1,xi2,yi,xS,yS,i,r,a,xT,angle,ray,rmi;
float col,n,nRays,nRays1,nRays2,Nb,Nbs,bi,alphaV,Rm,Tm,cosi,cosr,dcol;
public boolean ToggleNb = false, bover = false, locked = false;
public PFont font, CP5font;

public void setup(){
 size(CSizex,CSizey);
 background(255);
 smooth();
 
 nRays1 = 8; //order of refracted Rays for single impact parameter case
 nRays2 = 3; //order of refracted Rays for multiple impact parameter case
 Nbs = 20; //number of impact params
 b=200; //initial impact param
 xRD=400; //center pos x
 yRD=350; //center pos y
 n0=1.331f; //refarctive index
 dndl=0.015f; //dn/dlambda
 R=200; //radius of the drop
 PS=4; //marker size
 dcol = 0.8f/20;
 
 //initialize control sliders and checkboxes
 controlP5 = new ControlP5(this);
   font = createFont("Arial", 12); 
   textFont(font);
   ControlFont CP5font = new ControlFont(font); 
   controlP5.setControlFont(CP5font);
  
 Toggle ManyImpactP = controlP5.addToggle("ManyImpactParams", ToggleNb, 20, 15, 20, 20);
    ManyImpactP.setValue(false);
    ManyImpactP.captionLabel().toUpperCase(false);
    ManyImpactP.setCaptionLabel("many impact parameters");
 
 Slider ImpactFine = controlP5.addSlider("impactparameter", 0.95f, 1, 0.95f, CSizex-710, 15, 680, 20);
   ImpactFine.captionLabel().toUpperCase(false);
   ImpactFine.setCaptionLabel("b");
 
 Slider ImpactN = controlP5.addSlider("Nimpactparam", 2, 200, 10, 50, 15, 100, 20);
   ImpactN.captionLabel().toUpperCase(false);
   ImpactN.setCaptionLabel("# of impact-parameters");
}

public void impactparameter(float theValue) {
    b = yRD - theValue*R;
}

public void Nimpactparam(int theValue) {
    Nbs = theValue;
}

public void ManyImpactParams(boolean theFlag) {
  ToggleNb=theFlag;
}

public void draw(){
  colorMode(HSB, 1,1,1,1);
  ellipseMode(CENTER);
  background(0.55f,0,0.1f,1);
    
  //Draw Drop of Radius R at (xRD,yRD)
    stroke(0); strokeWeight(2); fill(0.55f,1,1,1); //blue color filling
    ellipse(xRD,yRD,2*R,2*R);
    //ellipse(xRD,yRD,PS/2,PS/2);
  
  strokeWeight(1);
  
  if (ToggleNb==true) {Nb = Nbs; nRays=nRays2;} else {Nb = 0.1f; nRays=nRays1;}
  //go through impact parameters
  for (bi=yRD-0.995f*R; bi<=yRD; bi=bi+R/Nb) {
    //use static or running b
    if (ToggleNb==true) {b = bi;}
    //check if impact-parameter hits raindrop
    if (abs(b - yRD) <= R) {
      //incoming ray
        stroke(0,0,1,1);
        yi = b; 
        xi = FindStartX(b);
        line(0,yi,xi,yi);
      //incidence angle
        i = atan2(yRD-yi,xRD-xi);
        cosi = cos(i);
      //specularly reflected ray
        a = -tan(-2*i);
        if (a *(yRD-b) <= 0) {xS=CSizex;} else {xS=0;}
        yS = a*(xS-xi) + yi;
          cosr = cos(asin(sin(i)/n0));
          alphaV = (FresnelRs(n, cosi, cosr) + FresnelRp(n, cosi, cosr))/2;
        stroke(0,0,1,alphaV);
        line(xS,yS,xi,yi);
      //go through colors and do refraction & transmission
      for (col=0; col<0.8f; col=col+dcol) {
        //wavelength dependent refractive index
          n = n0 + dndl*col;
        //refraction angles
          r = asin(sin(i)/n);
          cosr = cos(r);
          rmi = r - i;
        //Fresnel Transmittance and Reflection coefficients  
          Rm = (FresnelRs(n, cosi, cosr) + FresnelRp(n, cosi, cosr))/2;
          Tm = 1 - Rm;
        //compute all rays
        yi = b; xi = FindStartX(b);      
        for (ray=0; ray<nRays; ray=ray+1) {
          //set starting point of ray to be end-point of last ray
            xS=xi; yS=yi;
          //get angle (and slope a) for internal reflection of order (ray)
            angle = rmi - ray*(PI - 2*r);
            a = -tan(angle);
          //end-point coordinates of ray-sphere intersection
            xi = FindIntersectionX(xS, a, yS-a*xS);
            yi = a*(xi-xS) + yS;
          //draw internally reflected ray
            alphaV = Tm*pow(Rm,ray); //intensity of the beam
            stroke(col,1,1,alphaV); //(1-col)
            line(xS,yS,xi,yi); //draw ray
          //transmitted ray
            alphaV = Tm*pow(Rm,ray)*Tm;
            stroke(col,1,1,alphaV);
            //angle of transmitted and refracted ray
              a = -tan(angle + (r - i));
            //draw transmitted ray to sketch boundary (left or right)
              if ((xS - xi) <= 0) {xT=CSizex;} else {xT=0;}
              line(xi,yi,xT,a*(xT-xi) + yi); //draw transmitted ray
        }
      }
    } else {
      stroke(0,0,1,1);
      line(0,b,CSizex,b);
   }
  } 
  //needed for particle dragging
    if (mouseX > xRD-R && mouseX < xRD+R && mouseY > yRD-R && mouseY < yRD+R) {
      bover = true;  
    } else {
      bover = false;
    }
}


public float FresnelRs(float n2, float cosi, float cosr){
  return pow(abs((cosi - n2*cosr)/(cosi + n2*cosr)), 2);
}
public float FresnelRp(float n2, float cosi, float cosr){
  return pow(abs((cosr - n2*cosi)/(cosr + n2*cosi)), 2);
}


//return x of equation: (x-xRD)^2+(b-yRD)^2=R^2, i.e. intersection of line y=b with circle around (xRD,yRD)
public float FindStartX(float b){
  float bmyRD = b-yRD;
  if (abs(b - yRD) <= R) {
    xS =  xRD - sqrt((R - bmyRD)*(R + bmyRD));
  } else {
    xS = 0;
  }
  return xS;
}

//return intersection coordinate x of line ax+b with circle around (xRD,yRD)
public float FindIntersectionX(float xS, float a, float b){
  //xS: x-coordinate of the start point of the line
  //a: slope of the line, b: offset: y(x) = a*x + b 
  float opas = 1 + a*a;
  float yRDmb = yRD - b;
  float bpacRDmyRD = a*xRD - yRDmb;
  
  float st = sqrt(opas*R*R - bpacRDmyRD*bpacRDmyRD);
  float tt = a*yRDmb;
  xi1 =  (xRD - st + tt) / opas;
  xi2 =  (xRD + st + tt) / opas;
  if (abs(xi1 - xS) < R/100) {
    xi=xi2; //return xi2, since xi1 is the start point of the line ax+b
  } else {
    xi=xi1; //terurn xi1, since xi2 is the start point of the line ax+b
  }
  return xi;
}

public void mouseDragged() {
  if(locked) {
    xRD = mouseX-xRDn; //drag Raindrop, x
    yRD = mouseY-yRDn; //drag Raindrop, y
  } else {
    //set impact parameter
    if (ToggleNb==false) {
      b = mouseY;
    }
  }
}

public void mousePressed() {
  //Toggle Locked state, needed for dragging
  if(bover) { 
    locked = true; 
  } else {
    locked = false;
    //set impact parameter
    if (ToggleNb==false) {
      b = mouseY;
    }
  }
  xRDn = mouseX - xRD; // needed for dragging in x
  yRDn = mouseY - yRD; // needed for dragging in y
}

public float signum(float f) {
  if (f > 0) return 1.0f;
  if (f < 0) return -1.0f;
  return 0;
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "Raindrop" });
  }
}
